<?php
/**
 * @author Jaap Jansma <jaap.jansma@civicoop.org>
 * @license AGPL-3.0
 */

namespace Civi\DataProcessor\FieldOutputHandler;

class FieldOutput {

  public $rawValue;

  public $formattedValue;

  protected $isEmpty = null;

  public function __construct($rawValue=null) {
    $this->rawValue = $rawValue;
    $this->formattedValue = $rawValue;
  }

  public function isEmpty(): bool {
    return $this->rawValue === NULL || $this->rawValue === '';
  }

  public function overrideIsEmpty(bool $isEmpty): void {
    $this->isEmpty = $isEmpty;
  }

}
